/***********************
* Adobe Edge Animate コンポジションアクション
*
* このファイルを編集する際には注意が必要です。必ず関数シグニチャと
* 「Edge」で始まるコメントを保持して、 Adobe Edge 内からこれらのアクションを
* 操作可能な状態にしておいてください。 
*
***********************/
(function($, Edge, compId){
var Composition = Edge.Composition, Symbol = Edge.Symbol; // よく使用する Edge クラスのエイリアス

   //Edge symbol: 'stage'
   (function(symbolName) {
      
      
      Symbol.bindSymbolAction(compId, symbolName, "creationComplete", function(sym, e) {
         // battleData
         // battleDataは外部からはいってくる前提。
         // ターン数
         turnNum = 0;  // 全体で使うので var しない。
         // 連打防止フラグ
         isAnimate = false;  // 全体で使うので var しない。
         // ステータス反映
         for( var i = 0 ; i < battleData.startStatus.length ; i++ ){
         	var currentStatus = battleData.startStatus[ i ];
         	var statusElement = sym.getSymbol("TopIndex").getSymbol("OwnStatus" + i);
         	statusElement.$("NameText").html( currentStatus.Name );
         	statusElement.$("HPText").html( currentStatus.HP );
         	statusElement.$("SPText").html( currentStatus.SP );
         	statusElement.$("LVText").html( currentStatus.LV );
         }
         
         // 初回処理
         var currentTurn = battleData.turn[ turnNum ];
         // メッセージ反映
         sym.getSymbol("TopIndex").$("Message").html( currentTurn.message );
         // ターンのカウントを増やす
         turnNum++;

      });
      //Edge binding end

      Symbol.bindElementAction(compId, symbolName, "${_Stage}", "click", function(sym, e) {
         if( isAnimate ){
         	// アニメ中は動作しない。
         } else {
         	// 現在のターン
         	currentTurn = battleData.turn[ turnNum ];
         	nextTurn = battleData.turn[ turnNum + 1 ];
         	// modeによって表示分岐
         	if( currentTurn.mode == "attack" ) {
         		sym.getSymbol("TopIndex").$("Message").html( currentTurn.message );
         		sym.getSymbol("TopIndex").getSymbol( "Enemy" + currentTurn.effect.eid ).play( 2000 );
         		sym.getSymbol("TopIndex").getSymbol( "Slash" + currentTurn.effect.eid ).play( 500 );
         		sym.play(3000);
         		// アニメ中フラグ ON
         		isAnimate = true;
         	} else if( currentTurn.mode == "defence" ) {
         		sym.getSymbol("TopIndex").$("Message").html( currentTurn.message );
         		sym.getSymbol("TopIndex").getSymbol( "Enemy" + currentTurn.effect.eid ).play( 1000 );
         		sym.play(1500); // 画面揺れ
         		// ダメージ反映
         		var currentStatus = battleData.startStatus[ currentTurn.effect.id ];
         		var statusElement = sym.getSymbol("TopIndex").getSymbol("OwnStatus" + currentTurn.effect.id);
         		var afterHP = currentStatus.HP - currentTurn.effect.damage;
         		statusElement.$("HPText").html( afterHP );
         		// アニメ中フラグ ON
         		isAnimate = true;
         	} else if( currentTurn.mode == "finish" ) {
         		window.open("edge_battle_sample.html", "_self");
         	}
         
         	// ターンのカウントを増やす
         	turnNum++;
         }

      });
      //Edge binding end

      Symbol.bindTriggerAction(compId, symbolName, "Default Timeline", 2500, function(sym, e) {
         // アニメ中フラグのオフ
         isAnimate = false;
         // 停止
         sym.stop();

      });
      //Edge binding end

      Symbol.bindTriggerAction(compId, symbolName, "Default Timeline", 1250, function(sym, e) {
         // アニメ中フラグのオフ
         isAnimate = false;
         // 初回アニメ停止
         sym.stop();

      });
      //Edge binding end

      Symbol.bindTriggerAction(compId, symbolName, "Default Timeline", 1500, function(sym, e) {
         // 敵から攻撃を受けた際(defence)の開始位置

      });
      //Edge binding end

      Symbol.bindTriggerAction(compId, symbolName, "Default Timeline", 3000, function(sym, e) {
         // 攻撃した際(attack)の開始位置

      });
      //Edge binding end

      Symbol.bindTriggerAction(compId, symbolName, "Default Timeline", 3750, function(sym, e) {
         // アニメ中フラグのオフ
         isAnimate = false;
         // 死亡処理
         if( currentTurn.dead ){
         	sym.getSymbol("TopIndex").getSymbol( "Enemy" + currentTurn.dead.eid ).play( 3000 );
         }
         // 終了処理
         if( nextTurn.mode == "finish" ) {
         	// 終了演出
         	sym.getSymbol("TopIndex").$("Message").html( nextTurn.message );
         } else {
         	// 停止
         	sym.stop();
         }
         

      });
      //Edge binding end

      Symbol.bindTriggerAction(compId, symbolName, "Default Timeline", 4000, function(sym, e) {
         // finish演出の開始位置

      });
      //Edge binding end

      Symbol.bindTriggerAction(compId, symbolName, "Default Timeline", 5000, function(sym, e) {
         // 停止
         sym.stop();

      });
      //Edge binding end

   })("stage");
   //Edge symbol end:'stage'

   //=========================================================
   
   //Edge symbol: 'TopIndex'
   (function(symbolName) {   
   
   })("TopIndex");
   //Edge symbol end:'TopIndex'

   //=========================================================
   
   //Edge symbol: 'OwnStatus'
   (function(symbolName) {   
   
   })("OwnStatus");
   //Edge symbol end:'OwnStatus'

   //=========================================================
   
   //Edge symbol: 'Enemy'
   (function(symbolName) {   
   
      Symbol.bindTriggerAction(compId, symbolName, "Default Timeline", 750, function(sym, e) {
         sym.stop();

      });
      //Edge binding end

      Symbol.bindTriggerAction(compId, symbolName, "Default Timeline", 1750, function(sym, e) {
         sym.stop();

      });
      //Edge binding end

      Symbol.bindTriggerAction(compId, symbolName, "Default Timeline", 2835, function(sym, e) {
         sym.stop();

      });
      //Edge binding end

   })("Enemy");
   //Edge symbol end:'Enemy'

   //=========================================================
   
   //Edge symbol: 'Slash'
   (function(symbolName) {   
   
      Symbol.bindTriggerAction(compId, symbolName, "Default Timeline", 250, function(sym, e) {
         sym.stop();

      });
      //Edge binding end

      Symbol.bindTriggerAction(compId, symbolName, "Default Timeline", 1000, function(sym, e) {
         sym.stop();

      });
      //Edge binding end

   })("Slash");
   //Edge symbol end:'Slash'

})(jQuery, AdobeEdge, "EDGE-battle_sample");